#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
#include <deque>
#include <complex>

#define FOR(i,a,b) for(int i=(a),_b=(b); i<=_b; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b); i>=_b; i--)
#define REP(i,a) for(int i=0,_a=(a); i<_a; i++)
#define ll long long
#define F first
#define S second
#define PB push_back
#define MP make_pair
using namespace std;

//Buffer reading
int INP,AM;
#define BUFSIZE (1<<10)
char BUF[BUFSIZE+1], *inp=BUF;
#define GETCHAR(INP) { \
    if(!*inp) { \
        fread(BUF,1,BUFSIZE,stdin); \
        inp=BUF; \
    } \
    INP=*inp++; \
}
#define DIG(a) (((a)>='0')&&((a)<='9'))
#define GN(j) { \
    AM=0;\
    GETCHAR(INP); while(!DIG(INP) && INP!='-') GETCHAR(INP);\
    if (INP=='-') {AM=1;GETCHAR(INP);} \
    j=INP-'0'; GETCHAR(INP); \
    while(DIG(INP)){j=10*j+(INP-'0');GETCHAR(INP);} \
    if (AM) j=-j;\
}
//End of buffer reading

const double PI = acos(-1.0);
const int MN = 12-1;
const int oo = 1000111000;

int u, v, k, it[262144], ln[262144], a[50111];

#define CT(x) ((x)<<1)
#define CP(x) (CT(x) + 1)

inline void update(int i, int l, int r) {
    if (v < l || r < u) return ;
    if (u <= l && r <= v) {
        it[i] += k;
        ln[i] += k;
        return ;
    }
    if (r - l <= MN) {
        FOR(x,l,r)
            if (u <= x && x <= v) {
                a[x] += k;
                ln[i] = max(ln[i], a[x] + it[i]);
            }
        return ;
    }
    int mid = (l + r) >> 1;
    update(CT(i), l, mid);
    update(CP(i), mid+1, r);
    
    ln[i] = max(ln[CT(i)], ln[CP(i)]) + it[i];
}

inline int get(int i, int l, int r) {
    if (v < l || r < u) return -oo;
    if (u <= l && r <= v) return ln[i];
    
    if (r - l <= MN) {
        int res = -oo;
        FOR(x,l,r)
            if (u <= x && x <= v) {
                res = max(res, a[x]);
            }
        return res + it[i];
    }
    
    int mid = (l + r) >> 1;
    return max(get(CT(i), l, mid), get(CP(i), mid+1, r)) + it[i];
}

char output[30111000];
char *curOutPos, *s;

void write(int res) {
    if (!res) {
        (*curOutPos++) = '0';
        (*curOutPos++) = '\n';
        return ;
    }
    if (res < 0) {
        (*curOutPos++) = '-';
        res = -res;
    }
    s = curOutPos;
    while (res) {
        (*curOutPos++) = res%10 + '0';
        res /= 10;
    }
    
    reverse(s, curOutPos);
    (*curOutPos++) = '\n';
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    curOutPos = output;
    int n, m, q;
    GN(n); GN(m);
    while (m--) {
        GN(u); GN(v); GN(k);
        update(1,1,n);
    }
    GN(q);
    while (q--) {
        GN(u); GN(v);
        write(get(1,1,n));
    }
    fwrite(output, 1, curOutPos - output, stdout);
    return 0;
}
